// */**********************************************************************\*
// **                                                                      **
// ** Licensed Materials - Property of IBM                                 **
// ** (C) Copyright IBM Corp. 2005, 2007  All Rights Reserved.             **
// **                                                                      **
// ** US Government Users Restricted Rights - Use, duplication, or         **
// ** disclosure restricted by GSA ADP Schedule Contract with IBM Corp.    **
// **                                                                      **
// *\**********************************************************************/*
/*
 * Code  Reason   Rlse     Date    Origin   Comments                         
 * ----- -------- -------- ------- -------- --------------------------------
 * $F1   1555022  611      080715  BREIT    Command support added                      
 */
 
/**
 * Will be accessed by the drawTag function but shall not be used in relationship
 * with the cluster view.
 */
var shiftMode = false;
/**
 * Will be accessed by the drawTag function but shall not be used in relationship
 * with the cluster view.
 */
var zoneFlag = true;
/**
 * Will be called onLoad and fills the table initially.
 */
function main()
    {
    //start tags moving again
    try {
    	//get data passed to dialog
		var deserial = new deserializeArguments(dialogArguments);
		window.opener = deserial.windowOpener;
		myScope = window.opener.myScope;
    	onerror = handleErrors;
    	logger = deserial.windowOpener.logger;
    	fileAvailableCache = deserial.windowOpener.fileAvailableCache;
		iconFilterPrefix = "../" + window.opener.iconFilterPrefix;
		// get the embed object using getElementById!
		var embed = document.getElementById('clusterList');
    	var clusterDoc = embed.getSVGDocument();
	    var layer = clusterDoc.getElementById('tagLayer');
	    
	    // copy some global settings from the caller window
	    displaySearchResults = window.opener.displaySearchResults;
	    searchWindId = window.opener.searchWindId;
		
	    var tagInfo = deserial.tagInfo;
	    // how are the icons to be arranged?
		var numOfRows = Math.ceil(Math.sqrt(tagInfo.length));
		// set embedding tag for scrollbars of the embedding window
		embed.height = numOfRows * myScope.iconScale * 35 + 50;
		embed.width = embed.height; // remain 1:1 ratio
		var scaleFactor = 100 / embed.height; // 100 is the height of the viewBox of the svg.
		
		// $F1A
		document.onkeydown = checkKeyDown; // in keyCodeEvents.js.
	    document.onkeyup = checkKeyUp;     // in keyCodeEvents.js.
	    
	    //extract tagId
	    if (tagInfo.length > 0)
	        {
	        for (var i = 0; i < tagInfo.length; i++) {
	        	var xPos = (20 + Math.floor(i / numOfRows) * 35) * myScope.iconScale * scaleFactor;
	        	var yPos = (20 + (i % numOfRows) * 35) * myScope.iconScale * scaleFactor;
					//logger.info("tag.id/tag.iconLink: " + tagInfo[i].id + "/" + tagInfo[i].iconLink);
	        	drawTag(tagInfo[i], xPos, yPos, "processResult('" + tagInfo[i].id + "')", myScope.iconScale * scaleFactor, layer, clusterDoc);
	        }
	    }
    }
	catch(errorObject) {
        handleException(errorObject, arguments, 'main', 'tagClusterDialog.js');
	}
}

/**
 * Stores the id of the clicked tag in tagIdClicked.
 * 
 * @param {String} tagId The id of the tag that has been clicked.
 */   
function processResult(tagId)
{
	logger.trace('processResult(' + tagId + ') has been called');
	window.opener.catchClusterTagDialogClose(tagId, altMode);  // $F1C
	window.close();
	logger.trace('processResult(...) will be left');
}

function createClusterSVG() {
	try {
	    var svgExists = document.getElementById('clusterList');

	    if (svgExists != null)
	        document.body.removeChild(document.getElementById('clusterList'));
	
	    newSvg = document.createElement("embed");
	    newSvg.setAttribute("src", '../svg/clusterList.svg');
	    newSvg.setAttribute("id", 'clusterList')
	    newSvg.setAttribute("width", 180)
	    newSvg.setAttribute("height", 200)
	    newSvg.setAttribute("type", "image/svg+xml")
	    newSvg.setAttribute("pluginspage", "http://www.adobe.com/svg/viewer//install/");
	    newSvg.setAttribute("wmode", "transparent");
	    newSvg.style.setAttribute('cssText',
	                              'border-color:#c0c0c0; border-width:1px; border-style : solid;position: absolute; top:'
	                                  + 10 + '; left: ' + 10 + ';visibility: visible;',
	                              0)
	    document.body.appendChild(newSvg);
	    return newSvg;
    }
	catch(errorObject) {
        handleException(errorObject, arguments, 'createClusterSVG', 'tagClusterDialog.js');
	}
}

/**
 * Creates a new object deserializing the given parameters.
 * Changes here must be mirrored in the serializeArguments
 * function in tagDetailsManager.
 * 
 * @param {Array} param Array of arguments to be deserialized.
 * @return {Object} A new object containing the wanted data as members.
 */
function deserializeArguments(params)
{
	var index = 0;
	this.windowOpener  = params[index++];
	// initalize the tag infos
	this.tagInfo = params[index++];
}
